--- cgi/status.c.orig	2008-07-29 21:11:44.000000000 +0200
+++ cgi/status.c	2008-07-29 21:17:57.000000000 +0200
@@ -125,6 +125,8 @@
 
 void show_filters(void);
 
+void create_orphan_hosts_hostgroup();
+
 int passes_host_properties_filter(hoststatus *);
 int passes_service_properties_filter(servicestatus *);
 
@@ -240,6 +242,9 @@
 	/* get authentication information */
 	get_authentication_information(&current_authdata);
 
+	/* create a new hostgroup with orphaned hosts */
+	create_orphan_hosts_hostgroup();
+
 	/* if a navbar search was performed, find the host by name, address or partial name */
 	if(navbar_search==TRUE){
 		if((temp_host=find_host(host_name))==NULL){
@@ -5199,3 +5204,31 @@
         }
 
 
+/* Creates a host group with hosts which are not a member of any host group */
+void create_orphan_hosts_hostgroup() {
+
+    hostgroup *orphan_hostgroup;
+    host *temp_host;
+    hostgroup *temp_hostgroup;
+
+    orphan_hostgroup = add_hostgroup("orphans", "Orphan Hosts","","","");
+
+    if (orphan_hostgroup) {
+        for (temp_host=host_list;temp_host!=NULL;temp_host=temp_host->next) {
+            int found = 0;
+            for (temp_hostgroup=hostgroup_list;temp_hostgroup!=NULL;temp_hostgroup=temp_hostgroup->next) {
+                hostsmember *member;
+                for (member=temp_hostgroup->members;member!=NULL;member=member->next) {
+                    // Remember we have found this host
+                    if (strcmp(member->host_name,temp_host->name)==0)
+                        found++;
+                }
+            }
+            // If we didn't find this host in any host group, this is an orphaned host
+            if (found==0) {
+                add_host_to_hostgroup(orphan_hostgroup,temp_host->name);
+            }
+        }
+    }
+
+}
